var TabbrowserClick2Tab =
{
    init : function()
    {
        gBrowser.__removeTab = gBrowser.removeTab;
        gBrowser.removeTab = this.removeTab;
    },

    deinit : function()
    {
        gBrowser.removeTab = gBrowser.__removeTab;
    },

    removeTab : function (aTab)
    {
        if (aTab.localName != "tab")
            aTab = this.mCurrentTab;

        var l = this.mTabContainer.childNodes.length;
        if (l == 1) {
            if (!this.mPrefs.getBoolPref("browser.tabs.autoHide")) {
                // Clear the session history of the last tab, added by NetOne on 2004/11/16
                if (this.mPrefs.getBoolPref(prefStringClick2TabClearHistory)
                    && this.mCurrentBrowser.webNavigation.sessionHistory.count)
                    this.mCurrentBrowser.webNavigation.sessionHistory.PurgeHistory(this.mCurrentBrowser.webNavigation.sessionHistory.count);

                // blank the tab
                this.loadURI("about:blank");
                return;
            }
            // hide the tab bar
            this.mPrefs.setBoolPref("browser.tabs.forceHide", true);
            this.setStripVisibilityTo(false);
            return;
        }

        var ds = this.getBrowserForTab(aTab).docShell;

        if (ds.contentViewer && !ds.contentViewer.permitUnload())
            return;

        if (l == 2) {
            var autohide = this.mPrefs.getBoolPref("browser.tabs.autoHide");
            if (autohide)
                this.setStripVisibilityTo(false);
        }

        var index = -1;
        if (this.mCurrentTab == aTab)
            index = this.mPanelContainer.selectedIndex;
        else {
            // Find and locate the tab in our list.
            for (var i = 0; i < l; i++)
                if (this.mTabContainer.childNodes[i] == aTab)
            index = i;
        }

        // Remove the tab's filter and progress listener.
        const filter = this.mTabFilters[index];
        var oldBrowser = this.getBrowserAtIndex(index);
        oldBrowser.webProgress.removeProgressListener(filter);
        filter.removeProgressListener(this.mTabListeners[index]);
        this.mTabFilters.splice(index, 1);
        this.mTabListeners.splice(index, 1);

        // Remove our title change and blocking listeners
        oldBrowser.removeEventListener("DOMTitleChanged", this.onTitleChanged, false);

        // We are no longer the primary content area.
        oldBrowser.setAttribute("type", "content");

        // Now select the new tab before nuking the old one.
        var currentIndex = this.mPanelContainer.selectedIndex;

        var newIndex = -1;
        if (currentIndex > index)
            newIndex = currentIndex-1;
        else if (currentIndex < index)
            newIndex = currentIndex;
        else if (index == l - 1)
            newIndex = index-1;
        else
            newIndex = index;

        var oldTab = aTab;

        // clean up the before/afterselected attributes before removing the tab
        oldTab.selected = false;

        // XXX browser's destructor isn't always called, so we force a cleanup ourselves
        oldBrowser.destroy();

        this.mTabContainer.removeChild(oldTab);
        this.mPanelContainer.removeChild(this.mPanelContainer.childNodes[index]);

        this.selectedTab = this.mTabContainer.childNodes[newIndex];
        this.mPanelContainer.selectedIndex = newIndex;

        this.updateCurrentBrowser();
    }
};
